



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Mycat 全局系列号</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Mycat 全局系列号</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 00:44:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>标签：utf8</p>
<div>
<div>
<h2><strong>概述</strong></h2>
<p>本篇文章介绍mycat怎样在分库分表的情况下保证主键的全局唯一方法，接下来就来分析三种方法各自的优缺点。</p>
<h2><strong>配置</strong></h2>
<p><strong>文件方式获取</strong></p>
<p>1.修改server配置文件</p>
<p>vim server.xml</p>
<div>
<pre class="prettyprint linenums">&lt;system&gt;&lt;property name="sequnceHandlerType"&gt;0&lt;/property&gt;&lt;/system&gt;<br />
注：sequnceHandlerType 配置为0表示使用本地文件读取。</pre>
</div>
<p>2.配置sequence_conf.properties配置文件</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/135426/201601/135426-20160119174156984-904228369.png" /></p>
<p>3.在mycat中运行语句测试（在逻辑库中测试）</p>
<div>
<pre class="prettyprint linenums">insert into company(id,name) values(next value for MYCATSEQ_GLOBAL,'test');</pre>
</div>
<p><strong>缺点</strong>：在 MyCAT 重启后，配置文件中癿 sequence 会恢复到初始值。<br /><strong>优点</strong>：本地加载，读取速度较快。</p>
<p><strong>数据库方式获取</strong></p>
<p>1.修改server配置文件</p>
<p>vim server.xml</p>
<div>
<pre class="prettyprint linenums">&lt;system&gt;&lt;property name="sequnceHandlerType"&gt;1&lt;/property&gt;&lt;/system&gt;<br />
注：sequnceHandlerType 配置为1表示从数据库表中读取。</pre>
</div>
<p>2.配置读取的节点，就是配置全局表在哪个节点上面，我这里配置在dn1节点上面。</p>
<p>vim&nbsp;sequence_db_conf.properties</p>
<p><strong><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/135426/201601/135426-20160119175040422-1770582034.png" /></strong></p>
<p>3.创建全局表和函数</p>
<p>选择mysql物理库的dn1节点上执行下面语句，我配置的dn1即db1数据库</p>
<div>
<pre class="prettyprint linenums">DROP TABLE IF EXISTS MYCAT_SEQUENCE;<br />
CREATE TABLE MYCAT_SEQUENCE (<br />
NAME VARCHAR (50) NOT NULL,<br />
current_value INT NOT NULL,<br />
increment INT NOT NULL DEFAULT 100,<br />
PRIMARY KEY (NAME)<br />
) ENGINE = INNODB ;

INSERT INTO MYCAT_SEQUENCE(name,current_value,increment) VALUES ('GLOBAL', 100000, 100);

DROP FUNCTION IF EXISTS `mycat_seq_currval`;<br />
DELIMITER ;;<br />
CREATE  FUNCTION `mycat_seq_currval`(seq_name VARCHAR(50))<br />
RETURNS varchar(64) CHARSET utf8<br />
    DETERMINISTIC<br />
BEGIN<br />
        DECLARE retval VARCHAR(64);<br />
        SET retval="-999999999,null";<br />
        SELECT concat(CAST(current_value AS CHAR),",",CAST(increment AS CHAR) ) INTO retval<br />
          FROM MYCAT_SEQUENCE  WHERE name = seq_name;<br />
        RETURN retval ;<br />
END<br />
;;<br />
DELIMITER ;

DROP FUNCTION IF EXISTS `mycat_seq_nextval`;<br />
DELIMITER ;;<br />
CREATE FUNCTION `mycat_seq_nextval`(seq_name VARCHAR(50)) RETURNS varchar(64)<br />
 CHARSET utf8<br />
    DETERMINISTIC<br />
BEGIN<br />
         UPDATE MYCAT_SEQUENCE<br />
                 SET current_value = current_value + increment<br />
                  WHERE name = seq_name;<br />
         RETURN mycat_seq_currval(seq_name);<br />
END<br />
;;<br />
DELIMITER ;

DROP FUNCTION IF EXISTS `mycat_seq_setval`;<br />
DELIMITER ;;<br />
CREATE FUNCTION `mycat_seq_setval`(seq_name VARCHAR(50), value INTEGER)<br />
RETURNS varchar(64) CHARSET utf8<br />
    DETERMINISTIC<br />
BEGIN<br />
         UPDATE MYCAT_SEQUENCE<br />
                   SET current_value = value<br />
                   WHERE name = seq_name;<br />
         RETURN mycat_seq_currval(seq_name);<br />
END<br />
;;<br />
DELIMITER ;</pre>
</div>
<p>4.测试插入数据，也是在mycat逻辑库上执行</p>
<div>
<pre class="prettyprint linenums">insert into user(id,name) values(next value for MYCATSEQ_GLOBAL,'中文');</pre>
</div>
<p><strong>优点</strong>：在 MyCAT 重启后，sequence 值不会被初始化，比如当前MYCAT_SEQUENCE的初始值是100000，当mycat的重启之后再执行插入数据后MYCAT_SEQUENCE的初始值就加100变成100100，新插入到表的值也是在加100的基础上开始递增，</p>
<p>。</p>
<p><strong>缺点</strong>：当配置了主从复制时（A主B从），一开始主从上面的MYCAT_SEQUENCE表的current_value初始值是100000；当前配置的读写分离方案是A负责写B负责读当A宕机之后B负责写A变成了读，加入现在的全局ID已经到了&nbsp;100103，这个时候如果A宕机了，</p>
<p>mycat应该是存在缓存current_value还是记录的是A的值，不会立马切换使用B上的current_value的值，如果这个时候mycat重启了，这个时候全局系列号就开始使用B中的current_value值由于B值也是从100100开始那么这个时候插入全局记录到B中的表中就会和之前生成的100100到100103主键冲突了。不知道这算不算是一个BUG，所以当A宕机之后需要赶紧把A重启好，这样的话就算mycat重启之后还是从A开始读，这个时候全局ID就从100200开始了。</p>
<p>还有一种方法是当A宕机之后由于mycat还没有重启全局序列的ID还是缓存之前A的，这个时候把B的current_value增加100，这个时候如果切换到了A由于B的值是从100100开始不会和之前的冲突，如果这个时候A修复启动了这个时候也要把A的current_value增加200避免切换到A之后又和现在的值冲突。</p>
<p><strong>本地时间戳方式获取</strong></p>
<p>1.修改server配置文件</p>
<p>vim server.xml</p>
<div>
<pre class="prettyprint linenums">&lt;system&gt;&lt;property name="sequnceHandlerType"&gt;2&lt;/property&gt;&lt;/system&gt;<br />
注：sequnceHandlerType 配置为2表示时间戳方式。</pre>
</div>
<p>2.测试插入数据，也是在mycat逻辑库上执行，注意时间戳的长度有18位，保证表的字段长度足够</p>
<div>
<pre class="prettyprint linenums">insert into user(id,name) values(next value for MYCATSEQ_GLOBAL,'中文');</pre>
</div>
<p><strong>优点：</strong>不存在上面两种方案因为mycat的重启导致id重复的现象</p>
<p><strong>缺点：</strong>数据类型太长</p>
<h2><strong>总结</strong></h2>
<p>三种方式各有优缺点，根据自己的需求选择。</p>
<div>
</div>
<table>
<tbody>
<tr>
<td>
<p>备注：</p>
<p>作者：<a href="http://www.cnblogs.com/chenmh/" rel="external nofollow noreferrer">pursuer.chen</a></p>
<p>博客：<a href="http://www.cnblogs.com/chenmh/" rel="external nofollow noreferrer">http://www.cnblogs.com/chenmh</a></p>
<p>本站点所有随笔都是原创，欢迎大家转载；但转载时必须注明文章来源，且在文章开头明显处给明链接。</p>
<p>《欢迎交流讨论》</p>
</td>
</tr>
</tbody>
</table>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdy0pxq.html">Visual Studio 2015里面汇编工具Asm Dude的配置！</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn7kmj8.html">Intelli IDEA 14&period;04开发版&plus;注册码</a>
		</li>
						<li><a href="https://www.batexi.com/a/49561368.html">C与C&plus;&plus;的细微区别&mdash;&mdash;省略形式参数名</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7453xq.html">LoadRunner11支持的浏览器小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q27xov8.html">jQuery 两种方法实现IE10以下浏览器的placeholder效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p10gd9.html">解决：Detected memory leaks</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1m6mm9.html">&lbrack;目录&rsqb;Pentaho Kettle解决方案：使用PDI构建开源ETL解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdo17r8.html">LA 4670 &lpar;AC自动机 模板题&rpar; Dominating Patterns</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o7l349.html">java webservice的多种实现方法汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnww1rq.html">正确使用stl vecotr erase函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv154v1q.html">Jquery学习笔记：操作form表单元素之一（文本框和下拉框）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz6ve08.html">第四十六条：for-each循环优先于传统的for循环</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k16x49.html">转 c&num;性能优化秘密</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyn4xx9.html">BBS论坛（十四）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlljm60q.html">react-native上手篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjepxz9.html">《深入理解java虚拟机》读书笔记&mdash;&mdash;java内存区域和内存溢出异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy4k4jq.html">mysql 原理 ~ 线程与IO</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1gxmw9.html">OSGB数据压缩</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e46g4j9.html">SNF快速开发平台MVC-富文本控件集成了百度开源项目editor</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko0gyjq.html">MySQL&mdash;&mdash;约束&lpar;constraint&rpar;详解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/5qy1x1mq.html">2016 Google中国开发者大会游记</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4z2k09.html">追踪记录每笔业务操作数据改变的利器&mdash;&mdash;SQLCDC</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zo2wxq.html">VS低版本打开高版本解决方案（如08打开10、12、13版本vs编译的项目）</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2je3o8.html">java提升路线书单（原文自知乎刘欣）</a>
			</li>
						<li><a href="https://www.batexi.com/a/390m04j8.html">&lbrack;NHibernate&rsqb;第一个NHibernate的应用配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zop0xq.html">python 小程序 查找最大的python文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/49ge6n08.html">车销宝无线开单PDA 一款互联网&plus;POS神器 无缝与电脑数据同步 无线POS开单解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2jlvo8.html">该不该在C&num;中使用var关键词</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jz4508.html">最大流-最小割 MAXFLOW-MINCUT ISAP</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwjgkz8.html">【oracle】union、union all、intersect、minus 的用法及区别</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
